import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class F1 extends JFrame {
    private static final int FRAME_WIDTH = 300;
    private static final int FRAME_HEIGHT = 200;
    private static final int FRAME_X_ORIGIN = 150;
    private static final int FRAME_Y_ORIGIN = 250;

    public F1() {
        setTitle("My First JFrame Subclass");
        setSize(FRAME_WIDTH, FRAME_HEIGHT);
        setLocation(FRAME_X_ORIGIN, FRAME_Y_ORIGIN);
        
        setDefaultCloseOperation(EXIT_ON_CLOSE);

        // change background color
        Container contentPane = getContentPane();
        contentPane.setBackground(Color.lightGray);

        // layout GUI objects with a flow layout manager
        contentPane.setLayout(new FlowLayout());

        // push button
        JButton okButton = new JButton("OK");
        JButton cancelButton = new JButton("CANCEL");
        contentPane.add(okButton);
        contentPane.add(cancelButton);

        ButtonHandler handler = new ButtonHandler();
        okButton.addActionListener(handler);

        cancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent event) {
                JButton clickedButton = (JButton) event.getSource();
                JRootPane rootPane = clickedButton.getRootPane();
                JFrame frame = (JFrame) rootPane.getParent();
                frame.setTitle("You clicked " + clickedButton.getText());
            }
        }
        );

    }
}
